/*
polyprint.v1

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package polyprintapi

import (
	"encoding/json"
)

// checks if the NfcReorderRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &NfcReorderRequest{}

// NfcReorderRequest struct for NfcReorderRequest
type NfcReorderRequest struct {
	Address *NfcReorderRequestAddress `json:"address,omitempty"`
	ChannelId interface{} `json:"channel_id,omitempty"`
	CustomerExperienceId interface{} `json:"customer_experience_id,omitempty"`
	UserId interface{} `json:"user_id,omitempty"`
}

// NewNfcReorderRequest instantiates a new NfcReorderRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewNfcReorderRequest() *NfcReorderRequest {
	this := NfcReorderRequest{}
	return &this
}

// NewNfcReorderRequestWithDefaults instantiates a new NfcReorderRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewNfcReorderRequestWithDefaults() *NfcReorderRequest {
	this := NfcReorderRequest{}
	return &this
}

// GetAddress returns the Address field value if set, zero value otherwise.
func (o *NfcReorderRequest) GetAddress() NfcReorderRequestAddress {
	if o == nil || IsNil(o.Address) {
		var ret NfcReorderRequestAddress
		return ret
	}
	return *o.Address
}

// GetAddressOk returns a tuple with the Address field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NfcReorderRequest) GetAddressOk() (*NfcReorderRequestAddress, bool) {
	if o == nil || IsNil(o.Address) {
		return nil, false
	}
	return o.Address, true
}

// HasAddress returns a boolean if a field has been set.
func (o *NfcReorderRequest) HasAddress() bool {
	if o != nil && !IsNil(o.Address) {
		return true
	}

	return false
}

// SetAddress gets a reference to the given NfcReorderRequestAddress and assigns it to the Address field.
func (o *NfcReorderRequest) SetAddress(v NfcReorderRequestAddress) {
	o.Address = &v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *NfcReorderRequest) GetChannelId() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *NfcReorderRequest) GetChannelIdOk() (*interface{}, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return &o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *NfcReorderRequest) HasChannelId() bool {
	if o != nil && IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given interface{} and assigns it to the ChannelId field.
func (o *NfcReorderRequest) SetChannelId(v interface{}) {
	o.ChannelId = v
}

// GetCustomerExperienceId returns the CustomerExperienceId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *NfcReorderRequest) GetCustomerExperienceId() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.CustomerExperienceId
}

// GetCustomerExperienceIdOk returns a tuple with the CustomerExperienceId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *NfcReorderRequest) GetCustomerExperienceIdOk() (*interface{}, bool) {
	if o == nil || IsNil(o.CustomerExperienceId) {
		return nil, false
	}
	return &o.CustomerExperienceId, true
}

// HasCustomerExperienceId returns a boolean if a field has been set.
func (o *NfcReorderRequest) HasCustomerExperienceId() bool {
	if o != nil && IsNil(o.CustomerExperienceId) {
		return true
	}

	return false
}

// SetCustomerExperienceId gets a reference to the given interface{} and assigns it to the CustomerExperienceId field.
func (o *NfcReorderRequest) SetCustomerExperienceId(v interface{}) {
	o.CustomerExperienceId = v
}

// GetUserId returns the UserId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *NfcReorderRequest) GetUserId() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.UserId
}

// GetUserIdOk returns a tuple with the UserId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *NfcReorderRequest) GetUserIdOk() (*interface{}, bool) {
	if o == nil || IsNil(o.UserId) {
		return nil, false
	}
	return &o.UserId, true
}

// HasUserId returns a boolean if a field has been set.
func (o *NfcReorderRequest) HasUserId() bool {
	if o != nil && IsNil(o.UserId) {
		return true
	}

	return false
}

// SetUserId gets a reference to the given interface{} and assigns it to the UserId field.
func (o *NfcReorderRequest) SetUserId(v interface{}) {
	o.UserId = v
}

func (o NfcReorderRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o NfcReorderRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Address) {
		toSerialize["address"] = o.Address
	}
	if o.ChannelId != nil {
		toSerialize["channel_id"] = o.ChannelId
	}
	if o.CustomerExperienceId != nil {
		toSerialize["customer_experience_id"] = o.CustomerExperienceId
	}
	if o.UserId != nil {
		toSerialize["user_id"] = o.UserId
	}
	return toSerialize, nil
}

type NullableNfcReorderRequest struct {
	value *NfcReorderRequest
	isSet bool
}

func (v NullableNfcReorderRequest) Get() *NfcReorderRequest {
	return v.value
}

func (v *NullableNfcReorderRequest) Set(val *NfcReorderRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableNfcReorderRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableNfcReorderRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableNfcReorderRequest(val *NfcReorderRequest) *NullableNfcReorderRequest {
	return &NullableNfcReorderRequest{value: val, isSet: true}
}

func (v NullableNfcReorderRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableNfcReorderRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


